import _F from './java/File';
export default class AbstractGenerator {
    static SEARCH_PATHS: string[];
    writeToFile(filename: any, contents: any): void;
    readTemplate(name: any): string;
    getTemplateReader(name: any): string | undefined;
    /**
     * Get the template file path with template dir prepended, and use the
     * library template if exists.
     *
     * Resolve from embeddedTemplate/library, than embeddedTemplate,  then templateDir
     *
     * @param config Codegen config
     * @param templateFile Template file
     * @return String Full template file path
     */
    getFullTemplateFile(config: any, templateFile: any): any;
    readResourceContents(resourceFilePath: any): string | undefined;
    embeddedTemplateExists(name: any): boolean;
    getCPResourcePath(name: any): any;
    protected _resolveFilePath(...paths: any[]): any;
    protected _resolveFile(...paths: any[]): _F | undefined;
}
