"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* tslint:disable:variable-name */
const AuthParser_1 = __importDefault(require("./auth/AuthParser"));
const ClientOpts_1 = __importDefault(require("./ClientOpts"));
class ClientOptInput {
    constructor() {
        this.__opts = new ClientOpts_1.default();
    }
    swagger(swagger) {
        this.setSwagger(swagger);
        return this;
    }
    opts(opts) {
        this.setOpts(opts);
        return this;
    }
    config(codegenConfig) {
        this.setConfig(codegenConfig);
        return this;
    }
    auth(urlEncodedAuthString) {
        this.setAuth(urlEncodedAuthString);
        return this;
    }
    getAuth() {
        return AuthParser_1.default.reconstruct(this.auths);
    }
    setAuth(urlEncodedAuthString) {
        this.auths = AuthParser_1.default.parse(urlEncodedAuthString);
    }
    getAuthorizationValues() {
        return this.auths;
    }
    getConfig() {
        return this.__config;
    }
    setConfig(config) {
        this.__config = config;
    }
    getOpts() {
        return this.__opts;
    }
    setOpts(opts) {
        this.__opts = opts;
    }
    getSwagger() {
        return this.__swagger;
    }
    setSwagger(swagger) {
        this.__swagger = swagger;
    }
}
exports.default = ClientOptInput;
//# sourceMappingURL=ClientOptInput.js.map