"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SECURITY = exports.RESPONSE = exports.PROPERTY = exports.PARAMETER = exports.OPERATION = exports.MODEL = void 0;
/* tslint:disable:variable-name */
const CodegenModel_1 = __importDefault(require("./CodegenModel"));
const CodegenOperation_1 = __importDefault(require("./CodegenOperation"));
const CodegenParameter_1 = __importDefault(require("./CodegenParameter"));
const CodegenProperty_1 = __importDefault(require("./CodegenProperty"));
const CodegenResponse_1 = __importDefault(require("./CodegenResponse"));
const CodegenSecurity_1 = __importDefault(require("./CodegenSecurity"));
class CodegenModelType {
    constructor(defaultImplementation) {
        this.ordinal = () => ALL.indexOf(this);
        this._defaultImplementation = defaultImplementation;
    }
    getDefaultImplementation() {
        return this._defaultImplementation;
    }
}
CodegenModelType.values = () => ALL;
const forType = (type) => new CodegenModelType(type);
exports.MODEL = forType(CodegenModel_1.default);
exports.OPERATION = forType(CodegenOperation_1.default);
exports.PARAMETER = forType(CodegenParameter_1.default);
exports.PROPERTY = forType(CodegenProperty_1.default);
exports.RESPONSE = forType(CodegenResponse_1.default);
exports.SECURITY = forType(CodegenSecurity_1.default);
const ALL = [exports.MODEL, exports.OPERATION, exports.PARAMETER, exports.PROPERTY, exports.RESPONSE, exports.SECURITY];
exports.default = {
    MODEL: exports.MODEL,
    OPERATION: exports.OPERATION,
    PARAMETER: exports.PARAMETER,
    PROPERTY: exports.PROPERTY,
    RESPONSE: exports.RESPONSE,
    SECURITY: exports.SECURITY,
};
//# sourceMappingURL=CodegenModelType.js.map