export default class CodegenOperation {
    responseHeaders: never[];
    hasMore: boolean;
    isResponseBinary: boolean;
    hasReference: boolean;
    allParams: never[];
    bodyParams: never[];
    pathParams: never[];
    queryParams: never[];
    headerParams: never[];
    formParams: never[];
    responses: never[];
    imports: import("./java/FakeHashSet").FakeHashSet;
    httpMethod: any;
    baseName: any;
    path: any;
    /**
     * Check if act as Restful index method
     *
     * @return true if act as Restful index method, false otherwise
     */
    isRestfulIndex(): boolean;
    /**
     * Check if act as Restful show method
     *
     * @return true if act as Restful show method, false otherwise
     */
    isRestfulShow(): boolean;
    /**
     * Check if act as Restful create method
     *
     * @return true if act as Restful create method, false otherwise
     */
    isRestfulCreate(): boolean;
    /**
     * Check if act as Restful update method
     *
     * @return true if act as Restful update method, false otherwise
     */
    isRestfulUpdate(): boolean;
    /**
     * Check if act as Restful destroy method
     *
     * @return true if act as Restful destroy method, false otherwise
     */
    isRestfulDestroy(): boolean;
    /**
     * Check if Restful-style
     *
     * @return true if Restful-style, false otherwise
     */
    isRestful(): boolean;
    /**
     * Get the substring except baseName from path
     *
     * @return the substring
     */
    pathWithoutBaseName(): any;
    /**
     * Check if the path match format /xxx/:id
     *
     * @return true if path act as member
     */
    isMemberPath(): boolean;
    toString(): string;
}
