"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.forValue = exports.OTHER = exports.DOCUMENTATION = exports.SERVER = exports.CLIENT = exports.CodegenType = void 0;
class CodegenType {
    constructor(type) {
        this.type = type;
    }
    toString() {
        return this.type;
    }
}
exports.CodegenType = CodegenType;
CodegenType.ordinal = () => ALL;
function makeType(type) {
    return new CodegenType(type);
}
exports.CLIENT = makeType('client');
exports.SERVER = makeType('server');
exports.DOCUMENTATION = makeType('documentation');
exports.OTHER = makeType('other');
const ALL = [exports.CLIENT, exports.SERVER, exports.DOCUMENTATION, exports.OTHER];
function forValue(value) {
    for (const type in ALL) {
        if (type.type === value.toLowerCase()) {
            return type;
        }
    }
}
exports.forValue = forValue;
exports.default = {
    CLIENT: exports.CLIENT,
    DOCUMENTATION: exports.DOCUMENTATION,
    OTHER: exports.OTHER,
    SERVER: exports.SERVER,
};
//# sourceMappingURL=CodegenType.js.map