"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ConfigHelp_1 = __importDefault(require("./cmd/ConfigHelp"));
const Generate_1 = __importDefault(require("./cmd/Generate"));
const Langs_1 = __importDefault(require("./cmd/Langs"));
const Meta_1 = __importDefault(require("./cmd/Meta"));
const cli_1 = require("./java/cli");
const ern_core_1 = require("ern-core");
/**
 * User: lanwen
 * Date: 24.03.15
 * Time: 17:56
 * <p>
 * Command line interface for swagger codegen
 * use `swagger-codegen-cli.jar help` for more info
 *
 * @since 2.1.3-M1
 */
class SwaggerCodegen {
    static async main(args) {
        return cli_1.Cli.builder('swagger-codegen-cli')
            .withDescription('Swagger code generator CLI. More info on swagger.io')
            .withDefaultCommand(Langs_1.default)
            .withCommands(Generate_1.default, Meta_1.default, Langs_1.default, cli_1.Help, ConfigHelp_1.default)
            .build()
            .parse(args);
    }
}
exports.default = SwaggerCodegen;
if (require.main === module) {
    SwaggerCodegen.main(process.argv.slice(2)).then((x) => ern_core_1.log.info(x), (err) => {
        ern_core_1.log.error(err.message);
        process.exit(1);
    });
}
//# sourceMappingURL=SwaggerCodegen.js.map