"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const CodegenConfigLoader_1 = __importDefault(require("../CodegenConfigLoader"));
const cli_1 = require("../java/cli");
const ern_core_1 = require("ern-core");
class ConfigHelp {
    constructor({ language }) {
        this.language = language;
    }
    run() {
        const config = CodegenConfigLoader_1.default.forName(this.language);
        ern_core_1.log.info('CONFIG OPTIONS');
        for (const langCliOption of config.cliOptions()) {
            {
                ern_core_1.log.info(`\t ${langCliOption.getOpt()}`);
                ern_core_1.log.info(`\t    ${langCliOption
                    .getOptionHelp()
                    .replace(new RegExp('\n', 'g'), '\n\t    ')}`);
            }
        }
    }
}
exports.default = ConfigHelp;
ConfigHelp.Usage = new cli_1.Command({ name: 'config-help', description: 'Config help for chosen lang' }, [
    {
        description: 'language to get config help for',
        hasArg: true,
        name: ['-l', '--lang'],
        required: true,
        title: 'language',
    },
]);
//# sourceMappingURL=ConfigHelp.js.map