import File from '../java/File';
import { Command } from '../java/cli';
export default class Meta {
    static Usage: Command;
    static TEMPLATE_DIR_CLASSPATH: string;
    static MUSTACHE_EXTENSION: string;
    /**
     * Converter method to process supporting files: execute with mustache,
     * or simply copy to destination directory
     *
     * @param targetDir - destination directory
     * @param data      - map with additional params needed to process templates
     * @return converter object to pass to lambdaj
     */
    static processFiles(targetDir: any, data: any): Writer;
    /**
     * Creates mustache loader for template using classpath loader
     *
     * @param generator - class with reader getter
     * @return loader for template
     */
    static loader(generator: any): Reader;
    /**
     * Converts package name to path on file system
     *
     * @param packageName - package name to convert
     * @return relative path
     */
    static asPath(packageName: any): any;
    outputFolder: string;
    name: string;
    targetPackage: string;
    swaggerVersion: any;
    constructor(values: any);
    getImplementationVersion(): string;
    run(): void;
}
export declare class Writer {
    targetDir: any;
    data: any;
    generator: any;
    constructor(targetDir: any, data: any);
    convert: (support: any) => File;
}
export declare class Reader {
    generator: any;
    constructor(generator: any);
    getTemplate(name: any): any;
}
