import ClientOptInput from '../ClientOptInput';
import { FakeHashMap } from '../java/fakeMap';
/**
 * A class that contains all codegen configuration properties a user would want to manipulate.
 * An instance could be created by deserializing a JSON file or being populated from CLI or Maven plugin parameters.
 * It also has a convenience method for creating a ClientOptInput class which is THE object DefaultGenerator.java needs
 * to generate code.
 */
export default class CodegenConfigurator {
    static toAbsolutePathStr(path: any): any;
    static fromFile(configFile: any): any;
    systemProperties: FakeHashMap;
    instantiationTypes: FakeHashMap;
    typeMappings: FakeHashMap;
    additionalProperties: FakeHashMap;
    importMappings: FakeHashMap;
    languageSpecificPrimitives: import("../java/FakeHashSet").FakeHashSet;
    dynamicProperties: FakeHashMap;
    gitUserId: string;
    gitRepoId: string;
    releaseNote: string;
    verbose: boolean;
    skipOverwrite: boolean;
    bridgeVersion: any;
    lang: any;
    inputSpec: any;
    outputDir: any;
    modelPackage: any;
    modelNamePrefix: any;
    modelNameSuffix: any;
    templateDir: any;
    auth: any;
    apiPackage: any;
    invokerPackage: any;
    groupId: any;
    artifactId: any;
    artifactVersion: any;
    library: any;
    httpUserAgent: any;
    constructor(opts?: any);
    setBridgeVersion(version: any): void;
    getBridgeVersion(): any;
    setLang(lang: any): this;
    setInputSpec(inputSpec: any): this;
    getInputSpec(): any;
    getOutputDir(): any;
    setOutputDir(outputDir: any): this;
    getModelPackage(): any;
    setModelPackage(modelPackage: any): this;
    getModelNamePrefix(): any;
    setModelNamePrefix(prefix: any): this;
    getModelNameSuffix(): any;
    setModelNameSuffix(suffix: any): this;
    isVerbose(): boolean;
    setVerbose(verbose: any): this;
    isSkipOverwrite(): boolean;
    setSkipOverwrite(skipOverwrite: any): this;
    getLang(): any;
    getTemplateDir(): any;
    setTemplateDir(templateDir: any): this;
    getAuth(): any;
    setAuth(auth: any): this;
    getApiPackage(): any;
    setApiPackage(apiPackage: any): this;
    getInvokerPackage(): any;
    setInvokerPackage(invokerPackage: any): this;
    getGroupId(): any;
    setGroupId(groupId: any): this;
    getArtifactId(): any;
    setArtifactId(artifactId: any): this;
    getArtifactVersion(): any;
    setArtifactVersion(artifactVersion: any): this;
    getSystemProperties(): FakeHashMap;
    setSystemProperties(systemProperties?: any): void;
    addSystemProperty(key: any, value: any): this;
    getInstantiationTypes(): FakeHashMap;
    setInstantiationTypes(instantiationTypes: any): this;
    addInstantiationType(key: any, value: any): this;
    getTypeMappings(): FakeHashMap;
    setTypeMappings(typeMappings: any): this;
    addTypeMapping(key: any, value: any): this;
    getAdditionalProperties(): FakeHashMap;
    setAdditionalProperties(additionalProperties: any): this;
    addAdditionalProperty(key: any, value: any): this;
    getImportMappings(): FakeHashMap;
    setImportMappings(importMappings: any): this;
    addImportMapping(key: any, value: any): this;
    setDynamicProperties(properties: any): void;
    getLanguageSpecificPrimitives(): import("../java/FakeHashSet").FakeHashSet;
    setLanguageSpecificPrimitives(languageSpecificPrimitives: any): this;
    addLanguageSpecificPrimitive(value: any): this;
    getLibrary(): any;
    setLibrary(library: any): this;
    getGitUserId(): string;
    setGitUserId(gitUserId: any): this;
    getGitRepoId(): string;
    setGitRepoId(gitRepoId: any): this;
    getReleaseNote(): string;
    setReleaseNote(releaseNote: any): this;
    getHttpUserAgent(): any;
    setHttpUserAgent(httpUserAgent: any): this;
    toClientOptInput(): Promise<ClientOptInput>;
    addDynamicProperty(name: any, value: any): this;
    getDynamicProperties(): FakeHashMap;
    handleDynamicProperties(codegenConfig: any): void;
    setVerboseFlags(): void;
    checkAndSetAdditionalProperty(property: any, valueToSet: any, propertyKey?: any): void;
}
