export declare function splitCommaSeparatedList(input: any): any[];
export declare function parseCommaSeparatedTuples(input: any): any[];
/**
 * Contains shared logic for applying key-value pairs and CSV strings
 * to specific settings in CodegenConfigurator.
 *
 * <p>
 * This class exists to facilitate testing. These methods could be applied
 * to CodegenConfigurator, but this complicates things when mocking CodegenConfigurator.
 * </p>
 */
export declare function applySystemPropertiesKvp(systemProperties: any, configurator: any): void;
export declare function applyInstantiationTypesKvp(instantiationTypes: any, configurator: any): void;
export declare function applyImportMappingsKvp(importMappings: any, configurator: any): void;
export declare function applyTypeMappingsKvp(typeMappings: any, configurator: any): void;
export declare function applyAdditionalPropertiesKvp(additionalProperties: any, configurator: any): void;
export declare function applyLanguageSpecificPrimitivesCsv(languageSpecificPrimitives: any, configurator: any): void;
export declare function createSetFromCsvList(csvProperty: any): import("../java/FakeHashSet").FakeHashSet;
export declare function createMapFromKeyValuePairs(commaSeparatedKVPairs: any): import("../java/fakeMap").FakeHashMap;
declare const _default: {
    applyAdditionalPropertiesKvp: typeof applyAdditionalPropertiesKvp;
    applyImportMappingsKvp: typeof applyImportMappingsKvp;
    applyInstantiationTypesKvp: typeof applyInstantiationTypesKvp;
    applyLanguageSpecificPrimitivesCsv: typeof applyLanguageSpecificPrimitivesCsv;
    applySystemPropertiesKvp: typeof applySystemPropertiesKvp;
    applyTypeMappingsKvp: typeof applyTypeMappingsKvp;
    createMapFromKeyValuePairs: typeof createMapFromKeyValuePairs;
    createSetFromCsvList: typeof createSetFromCsvList;
};
export default _default;
