"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IgnoreToken = void 0;
class IgnoreToken {
    constructor(name, pattern) {
        this.name = name;
        this.pattern = pattern;
        IgnoreToken[name] = this;
    }
    getPattern() {
        return this.pattern;
    }
    ordinal() {
        return ENUMS.indexOf(this);
    }
    toString() {
        return this.name;
    }
    equals(that) {
        if (that == null) {
            return false;
        }
        if (this === that) {
            return true;
        }
        if (typeof that === 'string') {
            return this.name === that;
        }
        return this.name === that.name;
    }
}
exports.IgnoreToken = IgnoreToken;
const ENUMS = [
    new IgnoreToken('COMMENT', null),
    new IgnoreToken('DIRECTORY_MARKER', '/'),
    new IgnoreToken('ESCAPED_EXCLAMATION', '\\!'),
    new IgnoreToken('ESCAPED_SPACE', '\\ '),
    new IgnoreToken('MATCH_ALL', '**'),
    new IgnoreToken('MATCH_ANY', '*'),
    new IgnoreToken('NEGATE', '!'),
    new IgnoreToken('PATH_DELIM', '/'),
    new IgnoreToken('ROOTED_MARKER', '/'),
    new IgnoreToken('TEXT', null),
];
exports.default = {
    COMMENT: ENUMS[0],
    DIRECTORY_MARKER: ENUMS[1],
    ESCAPED_EXCLAMATION: ENUMS[2],
    ESCAPED_SPACE: ENUMS[3],
    MATCH_ALL: ENUMS[4],
    MATCH_ANY: ENUMS[5],
    NEGATE: ENUMS[6],
    PATH_DELIM: ENUMS[7],
    ROOTED_MARKER: ENUMS[8],
    TEXT: ENUMS[9],
};
//# sourceMappingURL=IgnoreToken.js.map