export declare abstract class Rule {
    static Operation: {
        EXCLUDE: number;
        EXCLUDE_AND_TERMINATE: number;
        INCLUDE: number;
        NOOP: number;
    };
    syntax: any;
    definition: any;
    constructor(syntax: any, definition: any);
    getDefinition(): any;
    getPattern(): any;
    /**
     * Whether or not the rule should be negated. !foo means foo should be removed from previous matches.
     * Example: **\/*.bak excludes all backup. Adding !/test.bak will include test.bak in the project root.
     * <p>
     * NOTE: It is not possible to re-include a file if a parent directory of that file is excluded.
     */
    getNegated(): any;
    evaluate(relativePath: any): number;
    getIncludeOperation(): number;
    getExcludeOperation(): number;
    protected abstract matches(relativePath: any): boolean;
}
