"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiGenUtils = exports.ApiGen = exports.CodegenConfigurator = exports.ClientOpts = exports.ClientOptInput = exports.Swagger = exports.CliOption = exports.SupportingFile = exports.DefaultCodegen = exports.DefaultGenerator = exports.ES6 = exports.Swift = exports.Android = void 0;
const ErnAndroidApiCodegen_1 = __importDefault(require("./languages/ErnAndroidApiCodegen"));
const SwiftCodegen_1 = __importDefault(require("./languages/SwiftCodegen"));
const ES6Codegen_1 = __importDefault(require("./languages/ES6Codegen"));
const DefaultGenerator_1 = __importDefault(require("./DefaultGenerator"));
const DefaultCodegen_1 = __importDefault(require("./DefaultCodegen"));
const SupportingFile_1 = __importDefault(require("./SupportingFile"));
const CliOption_1 = __importDefault(require("./CliOption"));
const Swagger_1 = __importDefault(require("./java/Swagger"));
const ClientOptInput_1 = __importDefault(require("./ClientOptInput"));
const ClientOpts_1 = __importDefault(require("./ClientOpts"));
const CodegenConfigurator_1 = __importDefault(require("./config/CodegenConfigurator"));
const apigen_1 = __importDefault(require("./apigen"));
const ApiGenUtils_1 = __importDefault(require("./ApiGenUtils"));
exports.Android = ErnAndroidApiCodegen_1.default;
exports.Swift = SwiftCodegen_1.default;
exports.ES6 = ES6Codegen_1.default;
exports.DefaultGenerator = DefaultGenerator_1.default;
exports.DefaultCodegen = DefaultCodegen_1.default;
exports.SupportingFile = SupportingFile_1.default;
exports.CliOption = CliOption_1.default;
exports.Swagger = Swagger_1.default;
exports.ClientOptInput = ClientOptInput_1.default;
exports.ClientOpts = ClientOpts_1.default;
exports.CodegenConfigurator = CodegenConfigurator_1.default;
exports.ApiGen = apigen_1.default;
exports.ApiGenUtils = ApiGenUtils_1.default;
exports.default = {
    Android: exports.Android,
    ES6: exports.ES6,
    Swift: exports.Swift,
};
//# sourceMappingURL=index.js.map