/**
 * TreeMap.js
 *
 * MIT License
 *
 * Copyright (c) 2016-2018 Adrian Wirth
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
/**
 * Modified implementation by @belemaire
 * - Classify implementation
 * - Add custom comparator support
 * - Add iterator
 */
export default class TreeMap {
    private keyComparator;
    private root;
    private keyType;
    private length;
    constructor(keyComparator?: any);
    checkKey(key: any, checkKeyType?: boolean): "string" | "number" | "boolean";
    call(callback: any, ...rest: any[]): void;
    getTree(): any;
    getLength(): any;
    each(callback: any): void;
    [Symbol.iterator](): Generator<any, void, any>;
    get(key: any): any;
    set(key: any, value: any): void;
    getMaxKey(): any;
    getMinKey(): any;
    getMaxNode(node: any): any;
    getMinNode(node: any): any;
    remove(key: any): void;
    lt(a: any, b: any): boolean;
    gt(a: any, b: any): boolean;
    private internalGet;
    private internalSet;
    private internalRemove;
    private internalEach;
}
