"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Help = void 0;
const padEnd_1 = __importDefault(require("lodash/padEnd"));
const Command_1 = require("./Command");
const ern_core_1 = require("ern-core");
const SORT_CMDS = (a, b) => a.Usage.name.localeCompare(b.Usage.name);
class Help {
    constructor(values, opts) {
        this.values = values;
        this.opts = opts;
    }
    run() {
        const { name, description, commands = [] } = this.opts;
        ern_core_1.log.info(`${name}\n${description}`);
        for (const cmd of commands.sort(SORT_CMDS)) {
            ern_core_1.log.info(`\t${(0, padEnd_1.default)(cmd.Usage.name, 20)} - ${cmd.Usage.description}`);
        }
    }
}
exports.Help = Help;
Help.Usage = new Command_1.Command({ name: 'help', description: 'This helpful message.' }, []);
//# sourceMappingURL=Help.js.map