import _newHashMap, { FakeHashMap } from './fakeMap';
export declare const newHashMap: typeof _newHashMap;
/**
 * This provides a bunch of Java like classes.  Collections, HashMap, HashSet
 * and a few conviences.   Attention has been paid to make it look very
 * similar, however they are not identically. Specifically "size" is not a function
 * it still a property.   This is mostly due to fear, of what will break if we change
 * that value.
 *
 * It should be useful for Java programmers coming to JS and for porting code from JS->JavaScript
 *
 * These classes are meant to be convient hence iteration.
 *
 */
export declare class HashSet {
    private set;
    contains(value: any): boolean;
    isEmpty(): boolean;
    add(val: any): boolean;
    addAll(itr: any): boolean;
    containsAll(itr: any): boolean;
    remove(val: any): boolean;
    removeAll(itr: any): boolean;
    retainAll(itr: any): boolean;
    toArray(): unknown[];
    toJSON(): any;
    toString(): string;
}
export declare const Collections: {
    sort(arr: any, comparator?: any): any;
    emptyList(): readonly never[];
    emptySet(): Readonly<import("./FakeHashSet").FakeHashSet>;
    emptyHashMap(): Readonly<FakeHashMap>;
};
export declare const Arrays: {
    asList(...args: any[]): any[];
};
export declare const Lists: {
    transform(arr: any, fn: any): any;
    newArrayList(arr: any): any;
};
export declare const asMap: (obj: any) => Map<any, any> | import("./FakeHashSet").FakeHashSet | FakeHashMap;
export declare const newHashSet: (...arr: any[]) => import("./FakeHashSet").FakeHashSet;
export declare const isNotEmptySet: (set: any) => boolean;
