"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* tslint:disable:variable-name */
const AndroidClientCodegen_1 = __importDefault(require("../languages/AndroidClientCodegen"));
const ERNMixin_1 = __importDefault(require("./ERNMixin"));
const javaUtil_1 = require("../java/javaUtil");
class ErnAndroidApiCodegen extends AndroidClientCodegen_1.default {
    constructor() {
        super(...arguments);
        this.sourceFolder = 'lib/src/main/java';
        this.platformVersion = '1.3.0';
        this.library = 'ern';
        this.__supportedLibraries = (0, javaUtil_1.newHashMap)([
            'ern',
            'ERN plugin makes this platform work',
        ]);
    }
    addSupportingFilesForErn() {
        this.__apiTemplateFiles.put('apirequests.mustache', '.java');
        this.__apiTemplateFiles.put('apievents.mustache', '.java');
        this.__apiDataTemplateFile.put('apidatamodel.mustache', '.java');
    }
    getName() {
        return 'ERNAndroid';
    }
}
exports.default = ErnAndroidApiCodegen;
(0, ERNMixin_1.default)(ErnAndroidApiCodegen);
//# sourceMappingURL=ErnAndroidApiCodegen.js.map