import DefaultCodegen from '../DefaultCodegen';
export default class JavascriptClientCodegen extends DefaultCodegen {
    static PROJECT_NAME: string;
    static MODULE_NAME: string;
    static PROJECT_DESCRIPTION: string;
    static PROJECT_VERSION: string;
    static PROJECT_LICENSE_NAME: string;
    static USE_PROMISES: string;
    static USE_INHERITANCE: string;
    static EMIT_MODEL_METHODS: string;
    static EMIT_JS_DOC: string;
    static reconcileInlineEnums(codegenModel: any, parentCodegenModel: any): any;
    sourceFolder: string;
    localVariablePrefix: string;
    emitJSDoc: boolean;
    apiDocPath: string;
    modelDocPath: string;
    apiTestPath: string;
    modelTestPath: string;
    usePromises: boolean;
    emitModelMethods: boolean;
    __outputFolder: string;
    __templateDir: string;
    __apiPackage: string;
    __modelPackage: string;
    __typeMapping: import("../java/fakeMap").FakeHashMap;
    _swaggerToFlowMapping: import("../java/fakeMap").FakeHashMap;
    __languageSpecificPrimitives: import("../java/FakeHashSet").FakeHashSet;
    projectVersion: any;
    projectDescription: any;
    projectName: any;
    moduleName: any;
    invokerPackage: any;
    constructor();
    initalizeCliOptions(): void;
    getTag(): import("../CodegenType").CodegenType;
    getName(): string;
    getHelp(): string;
    processOpts(): void;
    preprocessSwagger(swagger: any): void;
    escapeReservedWord(name: any): string;
    /**
     * Concatenates an array of path segments into a path string.
     * @param segments The path segments to concatenate. A segment may contain either of the file separator characters '\' or '/'.
     * A segment is ignored if it is <code>null</code>, empty or &quot;.&quot;.
     * @return A path string using the correct platform-specific file separator character.
     */
    createPath(...segments: any[]): string;
    apiTestFileFolder(): string;
    modelTestFileFolder(): string;
    apiFileFolder(): string;
    modelFileFolder(): string;
    apiDocFileFolder(): string;
    modelDocFileFolder(): string;
    toApiDocFilename(name: any): string;
    toModelDocFilename(name: any): any;
    toApiTestFilename(name: any): string;
    toModelTestFilename(name: any): string;
    toVarName(name: any): any;
    toParamName(name: any): any;
    toModelName(name: any): any;
    toModelFilename(name: any): any;
    toModelImport(name: any): any;
    toApiImport(name: any): string;
    getTypeDeclaration(p: any): any;
    toDefaultValue(p: any): any;
    toDefaultValueWithParam(name: any, p: any): string;
    setParameterExampleValue(p: any): void;
    /**
     * Normalize type by wrapping primitive types with single quotes.
     *
     * @param type Primitive type
     * @return Normalized type
     */
    normalizeType(type: any): any;
    getSwaggerType(p: any): any;
    toOperationId(operationId: any): any;
    fromOperation(pp: any, httpMethod: any, operation: any, definitions: any, swagger: any): any;
    fromModel(name: any, model: any, allDefinitions: any): any;
    sanitizePath(p: any): any;
    trimBrackets(s: any): any;
    getModelledType(dataType: any): string;
    getJSDocType(cm: any, cp?: any): any;
    isModelledType(cp: any): any;
    postProcessOperations(objs: any): any;
    postProcessModels(objs: any): any;
    needToImport(type: any): boolean;
    staticsanitizePackageName(packageName: any): any;
    toEnumName(property: any): string;
    toEnumVarName(value: any, datatype: any): any;
    toEnumValue(value: any, datatype: any): any;
    escapeQuotationMark(input: any): any;
    escapeUnsafeCharacters(input: any): any;
}
