import DefaultCodegen from '../DefaultCodegen';
export default class SwiftCodegen extends DefaultCodegen {
    static readonly PROJECT_NAME = "projectName";
    static readonly RESPONSE_AS = "responseAs";
    static readonly UNWRAP_REQUIRED = "unwrapRequired";
    static readonly POD_SOURCE = "podSource";
    static readonly POD_AUTHORS = "podAuthors";
    static readonly POD_SOCIAL_MEDIA_URL = "podSocialMediaURL";
    static readonly POD_DOCSET_URL = "podDocsetURL";
    static readonly POD_LICENSE = "podLicense";
    static readonly POD_HOMEPAGE = "podHomepage";
    static readonly POD_SUMMARY = "podSummary";
    static readonly POD_DESCRIPTION = "podDescription";
    static readonly POD_SCREENSHOTS = "podScreenshots";
    static readonly POD_DOCUMENTATION_URL = "podDocumentationURL";
    static readonly SWIFT_USE_API_NAMESPACE = "swiftUseApiNamespace";
    static readonly DEFAULT_POD_AUTHORS = "Swagger Codegen";
    static readonly LIBRARY_PROMISE_KIT = "PromiseKit";
    static readonly RESPONSE_LIBRARIES: string[];
    static normalizePath(path: any): string;
    projectName: string;
    responseAs: never[];
    sourceFolder: string;
    unwrapRequired: boolean;
    swiftUseApiNamespace: boolean;
    __outputFolder: string;
    __embeddedTemplateDir: string;
    __templateDir: string;
    __apiPackage: string;
    __modelPackage: string;
    __typeMapping: import("../java/fakeMap").FakeHashMap;
    __defaultIncludes: import("../java/FakeHashSet").FakeHashSet;
    __reservedWords: import("../java/FakeHashSet").FakeHashSet;
    __importMapping: import("../java/fakeMap").FakeHashMap;
    __languageSpecificPrimitives: import("../java/FakeHashSet").FakeHashSet;
    constructor();
    initalizeCliOptions(): void;
    getTag(): import("../CodegenType").CodegenType;
    getName(): string;
    getHelp(): string;
    processOpts(): void;
    isReservedWord(word: any): boolean;
    escapeReservedWord(name: any): string;
    modelFileFolder(): string;
    apiFileFolder(): string;
    getTypeDeclaration(p: any): any;
    getSwaggerType(p: any): any;
    isDataTypeBinary(dataType: any): boolean;
    /**
     * Output the proper model name (capitalized)
     *
     * @param name the name of the model
     * @return capitalized model name
     */
    toModelName(name: any): any;
    /**
     * Return the capitalized file name of the model
     *
     * @param name the model name
     * @return the file name of the model
     */
    toModelFilename(name: any): any;
    toDefaultValue(p: any): null;
    toInstantiationType(p: any): string | null;
    fromProperty(name: any, p: any): any;
    toSwiftyEnumName(value: any): any;
    toApiName(name: any): string;
    toOperationId(operationId: any): any;
    toVarName(name: any): any;
    toParamName(name: any): any;
    fromOperation(path: any, httpMethod: any, operation: any, definitions: any, swagger: any): any;
    setProjectName(projectName: any): void;
    setUnwrapRequired(unwrapRequired: any): void;
    setResponseAs(responseAs: any): void;
    toEnumValue(value: any, datatype: any): any;
    toEnumDefaultValue(value: any, datatype: any): string;
    toEnumVarName(name: any, datatype: any): any;
    toEnumName(property: any): any;
    postProcessModels(objs: any): any;
    escapeQuotationMark(input: any): any;
    escapeUnsafeCharacters(input: any): any;
}
