"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AUTHS = void 0;
const ApiKeyAuthDefinition_1 = __importDefault(require("./auth/ApiKeyAuthDefinition"));
const BasicAuthDefinition_1 = __importDefault(require("./auth/BasicAuthDefinition"));
const OAuth2Definition_1 = __importDefault(require("./auth/OAuth2Definition"));
const beanUtils_1 = require("../java/beanUtils");
exports.AUTHS = [
    ApiKeyAuthDefinition_1.default,
    BasicAuthDefinition_1.default,
    OAuth2Definition_1.default,
];
const resolve = (def) => {
    if (def == null || def.type == null) {
        return null;
    }
    for (const o of exports.AUTHS) {
        if (o.TYPE === def.type) {
            return o;
        }
    }
};
function authFactory(definition) {
    const Type = resolve(definition);
    if (Type == null) {
        throw new Error(`Unknown Auth Type for :${JSON.stringify(definition)}`);
    }
    return (0, beanUtils_1.apply)(new Type(), definition);
}
exports.default = authFactory;
//# sourceMappingURL=auth.js.map