"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const javaUtil_1 = require("../../java/javaUtil");
class AbstractSecuritySchemeDefinition {
    constructor() {
        this.vendorExtensions = (0, javaUtil_1.newHashMap)();
    }
    getVendorExtensions() {
        return this.vendorExtensions;
    }
    getType() {
        return this.type;
    }
    setType(type) {
        this.type = type;
    }
    setVendorExtension(name, value) {
        if (name.startsWith('x-')) {
            this.vendorExtensions.put(name, value);
        }
    }
    setVendorExtensions(vendorExtensions) {
        this.vendorExtensions = vendorExtensions;
    }
    getDescription() {
        return this.description;
    }
    setDescription(description) {
        this.description = description;
    }
    toJSON() {
        return {
            description: this.description,
            vendorExtensions: this.vendorExtensions,
        };
    }
}
exports.default = AbstractSecuritySchemeDefinition;
//# sourceMappingURL=AbstractSecuritySchemeDefinition.js.map