"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
const beanUtils_1 = require("../../java/beanUtils");
const Parameter_1 = require("./Parameter");
const BodyParameter_1 = require("./BodyParameter");
const CookieParameter_1 = require("./CookieParameter");
const FormParameter_1 = require("./FormParameter");
const HeaderParameter_1 = require("./HeaderParameter");
const PathParameter_1 = require("./PathParameter");
const QueryParameter_1 = require("./QueryParameter");
const RefParameter_1 = require("./RefParameter");
(0, beanUtils_1.beanify)(Parameter_1.Parameter.prototype, [
    'name',
    'enum',
    'in',
    'description',
    'required',
    'type',
    'items',
    'collectionFormat',
    'default',
    'maximum',
    'exclusiveMaximum',
    'minimum',
    'exclusiveMinimum',
    'maxLength',
    'minLength',
    'pattern',
    'maxItems',
    'minItems',
    'uniqueItems',
    'multipleOf',
    'format',
]);
const TYPES = [
    BodyParameter_1.BodyParameter,
    CookieParameter_1.CookieParameter,
    FormParameter_1.FormParameter,
    HeaderParameter_1.HeaderParameter,
    PathParameter_1.PathParameter,
    QueryParameter_1.QueryParameter,
    RefParameter_1.RefParameter,
];
function default_1(val) {
    if (val instanceof Parameter_1.Parameter) {
        return val;
    }
    for (const ParameterType of TYPES) {
        if (ParameterType.TYPE === val.in) {
            const ret = (0, beanUtils_1.apply)(new ParameterType(val), val);
            return ret;
        }
    }
    if ('$ref' in val) {
        const rp = new RefParameter_1.RefParameter(val);
        return (0, beanUtils_1.apply)(rp, val);
    }
    throw new Error(`Could not resolve parameter type: ${val.in}`);
}
exports.default = default_1;
__exportStar(require("./Parameter"), exports);
__exportStar(require("./BodyParameter"), exports);
__exportStar(require("./CookieParameter"), exports);
__exportStar(require("./FormParameter"), exports);
__exportStar(require("./HeaderParameter"), exports);
__exportStar(require("./PathParameter"), exports);
__exportStar(require("./QueryParameter"), exports);
__exportStar(require("./RefParameter"), exports);
__exportStar(require("./SerializableParameter"), exports);
//# sourceMappingURL=index.js.map