"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArrayProperty = void 0;
/* tslint:disable:variable-name */
const Property_1 = require("./Property");
const factory_1 = __importDefault(require("../factory"));
class ArrayProperty extends Property_1.Property {
    items(items) {
        this.setItems(items);
        return this;
    }
    getItems() {
        return this._items;
    }
    setItems(items) {
        this._items = (0, factory_1.default)(items, this);
    }
}
exports.ArrayProperty = ArrayProperty;
ArrayProperty.TYPE = 'array';
ArrayProperty.allowedProps = [
    ...Property_1.Property.allowedProps,
    'uniqueItems',
    'items',
    'maxItems',
    'minItems',
];
//# sourceMappingURL=ArrayProperty.js.map