"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RESPONSE = exports.PATH = exports.PARAMETER = exports.DEFINITION = exports.forValue = void 0;
function forValue(str) {
    str = str.toUpperCase();
    if (str in ALL) {
        return ALL[str];
    }
}
exports.forValue = forValue;
class RefType {
    static values() {
        return ENUMS;
    }
    constructor(internalPrefix) {
        this.internalPrefix = internalPrefix;
    }
    getInternalPrefix() {
        return this.internalPrefix;
    }
    ordinal() {
        return ENUMS.indexOf(this);
    }
}
RefType.forValue = forValue;
exports.DEFINITION = new RefType('#/definitions/');
exports.PARAMETER = new RefType('#/parameters/');
exports.PATH = new RefType('#/paths/');
exports.RESPONSE = new RefType('#/responses/');
const ALL = { DEFINITION: exports.DEFINITION, PARAMETER: exports.PARAMETER, PATH: exports.PATH, RESPONSE: exports.RESPONSE };
const ENUMS = Object.freeze(Object.keys(ALL).map((v) => ALL[v]));
exports.default = { ...ALL, forValue };
//# sourceMappingURL=RefType.js.map